* Local parameters
LPARAMETERS m.p_path

* Local variables
LOCAL xtesting, xobj_word, xerr_flag, xerr_handle, xart_parent, xfrm_name, xlng_type
LOCAL xcolndx, xsql, xrecndx, xfilename, xsql_sub, xlng_code
LOCAL xpar_desc, xextern

* Initial settings
xobj_word   = NULL
xtesting    = .T.
xerr_flag   = .F.
xart_parent = ""
xfrm_name   = ""
xlng_type   = 0
xcolndx     = 0
xsql        = ""
xrecndx     = 0
xfilename   = ""
xsql_sub    = ""
xlng_code   = ""
xpar_desc   = ""
xextern     = .F.

IF (xtesting) THEN
	*  Check for active form
	IF (VARTYPE(_screen.activeform) = "O") THEN

		* Check that we are in the list form
		IF (_screen.activeform.name = "frm_list") THEN
			* Retrieve makepart
			xart_parent = _screen.activeform.cnt_info_top.cnt_parent.txt_base.text
		ENDIF
	ENDIF
	
	* Make sure that we found a valid makepart
	xtesting = (NOT(xart_parent == ""))
ENDIF

IF (xtesting) THEN
	* Ask user what language must be used
	xlng_type = rreq_ans("/t:Gewenste taal/d:1", "Nederlands (intern)", "Nederlands (extern)", "Duits (extern)", "Engels (extern)")

	* Set default Word-template
	DO CASE
		* Nederlands (intern)
		CASE xlng_type = 1
			* Set filename
			xfilename = "hndstkin.doc"							
			xlng_code = "INT"
			xextern   = .F.
		* Nederlands (extern)
		CASE xlng_type = 2
			* Set filename
			xfilename = "hndstknl.doc"							
			xlng_code = "STD"
			xextern   = .T.			
		* Duits (extern)
		CASE xlng_type = 3
			* Set filename
			xfilename = "hndstkde.doc"							
			xlng_code = "DUI"
			xextern   = .T.						
		* Engels (extern)
		CASE xlng_type = 4
			* Set filename
			xfilename = "hndstkuk.doc"							
			xlng_code = "ENG"
			xextern   = .T.						
	ENDCASE
	
	* Make sure that we have a valid filename
	xtesting = (NOT(xfilename == ""))
ELSE
	DO dsp_msg WITH "/ok", "Geen hoofdartikel bekend!"
ENDIF	
	
IF (xtesting) THEN
	* Create full path to filename
	xfilename = m.p_path + "\" + xfilename
	
	* No errorhandling
	xerr_handle = ON('ERROR')
	ON ERROR xerr_flag = .T.

	* Create reference to Word application
	xobj_word = createobject("Word.application")

	* Make sure that the Excel object is created correctly
	IF (ISNULL(xobj_word)) THEN
		* Show message to user
		DO dsp_msg WITH "/ok", "Word-programma kan niet worden gestart!"
		
		* Don't process further
		xtesting = .F.
	ENDIF
ELSE
	DO dsp_msg WITH "/ok", xfilename
ENDIF

IF (xtesting) THEN
	* Show application
	xobj_word.application.visible = .T.
	xobj_word.application.windowstate = 0

	* Make sure that a filename is specified and is valid
	xtesting = NOT EMPTY(xfilename) AND FILE(xfilename)
ENDIF

IF (xtesting) THEN
	* Retrieve parent description (from longdesc)
    xpar_desc = rret_exp(PADR(ALLTRIM(xlng_code), 5) + PADR(ALLTRIM(xart_parent), 15), '/a:longdesc/t:lng_art/fld:art_desc')
    
    * If no long description is found, use default product description
    IF (ALLTRIM(xpar_desc) == "") THEN
    	* Retrieve article's description
    	xpar_desc = rret_exp(xart_parent, "/a:article/t:art_code/fld:art_desc1")
    ENDIF

	* Open Word document
    xobj_word.application.documents.Open(xfilename)

    IF xobj_word.application.ActiveWindow.View.SplitSpecial <> 0 THEN
        xobj_word.application.ActiveWindow.Panes(2).Close
    ENDIF
    IF (xobj_word.application.ActiveWindow.ActivePane.View.Type = 1) OR (xobj_word.application.ActiveWindow.ActivePane.View.Type = 2) THEN
        xobj_word.application.ActiveWindow.ActivePane.View.Type = 3
    ENDIF
    xobj_word.application.ActiveWindow.ActivePane.View.SeekView = 9
    xobj_word.application.Selection.Font.Size = 16
    * xobj_word.application.Selection.TypeText(xart_parent)
    xobj_word.application.Selection.TypeText(xpar_desc)
    
    xobj_word.application.Selection.MoveDown
    xobj_word.application.Selection.MoveDown

    * xobj_word.application.Selection.TypeText(xpar_desc)
	xobj_word.application.Selection.TypeText(xart_parent)
    
    xobj_word.application.ActiveWindow.ActivePane.View.SeekView = 0
ENDIF

IF (xtesting) THEN    
	* Open tables
	DO opn_tbl WITH "article, art_prbm, longdesc"

	* Build SQL	
	xsql = "SELECT art_prbm.pos_nr, art_prbm.art_qty, IIF(NOT ISNULL(MLINE(longdesc.art_desc,1)), PADR(MLINE(longdesc.art_desc, 1), 254), article.art_desc1) AS art_desc1, art_prbm.art_code, "
	xsql = xsql + "article.sup_ac, article.tekeningnr, article.ag_code, art_prbm.txt_word1, art_prbm.txt_word2, art_prbm.txt_word3 " 
	xsql = xsql + "FROM art_prbm inner join article on (article.art_code == art_prbm.art_code) "
	xsql = xsql + "LEFT JOIN longdesc ON (longdesc.art_code = art_prbm.art_code AND lng_code = '" + xlng_code + "') "
	xsql = xsql + "WHERE art_prbm.art_parent == '" + ALLTRIM(xart_parent) + "' "
	xsql = xsql + "ORDER BY art_prbm.pos_nr "
	xsql = xsql + "INTO CURSOR xxls_prbm "

	* Execute SQL
	&xsql

	* If any records found
	IF (_TALLY > 0) THEN
		* Process found records
		SCAN
			* New page
			IF (ALLTRIM(xxls_prbm.txt_word2) = "#") THEN
			    * New page
			    xobj_word.application.selection.insertbreak(7)
			ENDIF

			* Extra new line
			IF (ALLTRIM(xxls_prbm.txt_word1) = "@") THEN
				* Extra Enter
				xobj_word.application.selection.TypeText(CHR(13))
			ENDIF
		
		    xobj_word.application.selection.TypeText(ALLTRIM(xxls_prbm.pos_nr) + CHR(9))         && Positienummer
		    xobj_word.application.selection.TypeText(ALLTRIM(STR(xxls_prbm.art_qty)))   && Aantal
		    xobj_word.application.selection.TypeText(CHR(9))                            && Tab
		    xobj_word.application.selection.TypeText(ALLTRIM(xxls_prbm.art_desc1) + CHR(9))      && Omschrijving
		    xobj_word.application.selection.TypeText(xxls_prbm.art_code + CHR(9))       && Onderdeel
		    
		    * Intern
		    IF (NOT xextern) THEN
			    * Aggregaten
			    IF (INLIST(xxls_prbm.ag_code, 'A20', 'A21', 'A22')) THEN
				    xobj_word.application.selection.TypeText(xxls_prbm.sup_ac)          && Leverancierscode
		    	ENDIF
		    
			    * Trilblokken
			    IF (INLIST(xxls_prbm.ag_code, 'A01')) THEN
				    xobj_word.application.selection.TypeText(xxls_prbm.tekeningnr)          && Tekeningnummer
			    ENDIF
			ENDIF

		    * Enter
		    xobj_word.application.selection.TypeText(CHR(13))

			* Build up SQL subcommmand
			xsql_sub = "SELECT art_prbm.pos_nr, art_prbm.art_qty, IIF(NOT ISNULL(MLINE(longdesc.art_desc,1)), PADR(MLINE(longdesc.art_desc, 1), 254), article.art_desc1) AS art_desc1, art_prbm.art_code, "
			xsql_sub = xsql_sub + "article.sup_ac, article.tekeningnr, article.ag_code, art_prbm.txt_word1, art_prbm.txt_word2, art_prbm.txt_word3 " 
			xsql_sub = xsql_sub + "FROM art_prbm inner join article on (article.art_code == art_prbm.art_code) "
			xsql_sub = xsql_sub + "LEFT JOIN longdesc ON (longdesc.art_code = art_prbm.art_code AND lng_code = '" + xlng_code + "') "
			xsql_sub = xsql_sub + "WHERE art_prbm.art_parent == '" + ALLTRIM(xxls_prbm.art_code) + "' "
			xsql_sub = xsql_sub + "ORDER BY art_prbm.pos_nr "
			xsql_sub = xsql_sub + "INTO CURSOR xsub_prbm "
			
			* Execute SQL
			&xsql_sub	    
			
			* If any records found
			IF (_TALLY > 0) THEN
				SCAN
					* New page
					IF (ALLTRIM(xsub_prbm.txt_word2) = "#") THEN
					    * New page
					    xobj_word.application.selection.insertbreak(7)
					ENDIF

					* Extra new line
					IF (ALLTRIM(xsub_prbm.txt_word1) = "@") THEN
					    * Enter
					    xobj_word.application.selection.TypeText(CHR(13))
					ENDIF
				
				    xobj_word.application.selection.TypeText(CHR(9) + ALLTRIM(xsub_prbm.pos_nr) + CHR(9))        && Positienummer
				    xobj_word.application.selection.TypeText(ALLTRIM(STR(xsub_prbm.art_qty)))  && Aantal
				    xobj_word.application.selection.TypeText(CHR(9))                           && Tab
			    	xobj_word.application.selection.TypeText(ALLTRIM(xsub_prbm.art_desc1) + CHR(9))     && Omschrijving
				    xobj_word.application.selection.TypeText(xsub_prbm.art_code + CHR(9))      && Onderdeel

				    * Intern
				    IF (NOT xextern) THEN
			    		* Aggregaten
					    IF (INLIST(xsub_prbm.ag_code, 'A20', 'A21', 'A22')) THEN
						    xobj_word.application.selection.TypeText(xsub_prbm.sup_ac)             && Leverancierscode
					    ENDIF
		    
					    * Trilblokken
				    	IF (INLIST(xsub_prbm.ag_code, 'A01')) THEN
						    xobj_word.application.selection.TypeText(xsub_prbm.tekeningnr)        && Tekeningnummer
					    ENDIF
					ENDIF

				    * Enter
				    xobj_word.application.selection.TypeText(CHR(13))
				ENDSCAN
			ENDIF

			* Set tablepointer to main cursor again
			SELECT xxls_prbm
				
			* Increase record counter
			xrecndx = xrecndx + 1
		ENDSCAN
	ENDIF
ENDIF


IF (xtesting) THEN
	* Close Word object
 	xobj_word = NULL
	
	* Restore errorhandling
	ON ERROR &xerr_handle
ENDIF

* Finish
RETURN xtesting
