*HEADE FOR MEDIATOR COMMANDS/FUNCTION

/*** Additional commands**************************************/
#command DROP TABLE <tab> => MedDropTable(<"tab">)
#command DROP INDEX <idx> => MedDropIdx(SELECT(),<"idx">)

#command SET FIELDS TO <fields,...>	;
	=> MedSetFld( SELECT(), <"fields"> )

#command SET FIELDS TO 	;
	=> MedSetFld( SELECT() )

#command SET INACTIVE FIELDS READ <x:ON,OFF,&>  ;
	=> MedFldRd( <(x)> )

#command DISCONNECT	=> MedDisconn()

/* Constants for MedFltRes function*/
#define  OTC_FILTER_ON_CLIENT  0
#define  OTC_FILTER_ON_SERVER  1

#command SET FILTERING ON CLIENT ;
	=> MedSetFltS( 0 )

#command SET FILTERING ON SERVER ;
	=> MedSetFltS( 1 )

#command SET SQL FILTER TO <cexp>  ;
	=> MedSetOFil(SELECT(),<cexp>)

/* Constants for MedSetCP function */
#define OTC_CP_NO_CONV	  0
#define OTC_CP_MAZOWIA	  1
#define OTC_CP_852	  2
#define OTC_CP_MSWIN1250  3
#define OTC_CP_ISOLATIN2  4
#define OTC_CP_CUSTOM     5

#command SET SERVER CODE PAGE [TO]      	=> MedSetCPS(OTC_CP_NO_CONV)
#command SET SERVER CODE PAGE [TO] MAZOWIA	=> MedSetCPS(OTC_CP_MAZOWIA)
#command SET SERVER CODE PAGE [TO] CP852	=> MedSetCPS(OTC_CP_852)
#command SET SERVER CODE PAGE [TO] MSWIN1250	=> MedSetCPS(OTC_CP_MSWIN1250)
#command SET SERVER CODE PAGE [TO] ISOLATIN2	=> MedSetCPS(OTC_CP_ISOLATIN2)

#command SET CLIENT CODE PAGE [TO] 		=> MedSetCPC(OTC_CP_NO_CONV)
#command SET CLIENT CODE PAGE [TO] MAZOWIA	=> MedSetCPC(OTC_CP_MAZOWIA)
#command SET CLIENT CODE PAGE [TO] CP852	=> MedSetCPC(OTC_CP_852)
#command SET CLIENT CODE PAGE [TO] CUSTOM	=> MedSetCPC(OTC_CP_CUSTOM)


#command USE <(db)>                                                     ;
		  AS <select>						;
             [ALIAS <a>]                                                ;
             [<new: NEW>]                                               ;
	     [<sh: SHARED>]						;
	     [<ex: EXCLUSIVE>]						;
	     [<ro: READONLY>]						;
             [PRECISION <p>]						;
	     [<scr: SCROLLABLE>]					;
	     [<prmt: PERMANENT>]					;
	     [<ovr: OVERWRITE>]						;
	     [<c1log: C1LOGICAL>]					;
      => 	 MedSetQry( <select>, if(<.p.>,<p>,-1),<.scr.>,<.prmt.>,<.ovr.>,<.c1log.>);
      		;dbUseArea( <.new.>, "MEDNTX", <(db)>, <(a)>, 		;
                        if(<.sh.> .or. <.ex.>, !<.ex.>, NIL), <.ro.> )
 
#command SET QUERY PRECISION [TO] <p> =>  MedSetQP( <p> )
 
/******* Transaction system defines **********/

/* defines for MedTrRes() */
#define TRANS_SUCCESS		0
#define TRANS_TIMEOUT		1
#define TRANS_ROLLBACK  	2 

/* defines for MedTrMode */
#define TRN_MODE_MANUAL 0
#define TRN_MODE_AUTO	1
#command SET TRANSACTION MODE [TO] MANUAL => MedTrMode(TRN_MODE_MANUAL)
#command SET TRANSACTION MODE [TO] AUTO   => MedTrMode(TRN_MODE_AUTO)

#command BEGIN TRANSACTION   => 	MedTrBegin( 0 ) 
#command BEGIN TRANSACTION TIMEOUT <tv> => MedTrBegin( <tv> ) 
#command COMMIT TRANSACTION	=>	MedTrComm() 
#command ROLLBACK TRANSACTION   =>	MedTrRollb() 

#command SET LOCK TRY [TO]    	<rc>    => MedLockTry( <rc> )
#command SET LOCK INTERVAL [TO] <tv>    => MedLockItv( <tv> )

#command SET APPEND TIMEOUT [TO] 	=> MedAppTmt( 0 )
#command SET APPEND TIMEOUT [TO] <tm>   => MedAppTmt( <tm> )

/******* MedExecSQL() error handling */

/* SQL error modes */
#define OTC_SQL_ERROR_VERBOSE	0
#define OTC_SQL_ERROR_SILENT	1

/* error codes as returned by MedCmdRes()  */
#define OTC_CMD_SUCCESS		0

#command SET SQL ERROR VERBOSE	=>  MedSetSQLE( OTC_SQL_ERROR_VERBOSE )
#command SET SQL ERROR SILENT	=>  MedSetSQLE( OTC_SQL_ERROR_SILENT )

/* operating system constants as returned by MedSrvSys() */
#define SRV_SYS_NETWARE		1
#define SRV_SYS_NTX86		2

/* MedDiscTm() - application keepalive timeout constants */
#define APP_KEEPALIVE_DEFAULT   0
#define APP_KEEPALIVE_OFF       65535

/* ORACLE create table memo type for MedMemType() */
#define ORA_MEMO_LONG		1
#define ORA_MEMO_LONGRAW	2
#define MED_MEMO_LONG		1
#define MED_MEMO_LONGRAW	2

/* constants for MedChrIdxT() */
#define ORA_IDX_VARCHAR         0
#define ORA_IDX_CHAR            1
#define MED_IDX_VARCHAR         0
#define MED_IDX_CHAR            1

/* constants for MedGetFiles() */
#define MED_GETF_DBF		0
#define MED_GETF_NTX		1
#define MED_GETF_CDX		2

/**************************/
/* SQL driver definitions */
/**************************/

#define SQL_OPT_WHERE		1
#define SQL_OPT_ID		2
#define SQL_OPT_ORDER		3
#define SQL_OPT_FOR_UPDATE	4
#define SQL_OPT_INDEX_NAME      5
#define SQL_OPT_COLUMNS		6
#define SQL_OPT_EXACT_RECCOUNT  7
/* SQL_OPT_MEMO_TYPE values: 1 - LONG VARCHAR2, 2 - LONG ROW */
#define SQL_OPT_MEMO_TYPE	20

/* SQL create table memo type for SqlMemType() */
#define SQL_MEMO_LONG		1
#define SQL_MEMO_LONGRAW	2

#command SQL USE <(db)>                                                 ;
	     [VIA <rdd>]						;
             [ALIAS <a>]                                                ;
             [<new: NEW>]                                               ;
	     [<sh: SHARED>]						;
	     [<ro: READONLY>]						;
	     [WHERE <wcond>]						;
	     [IDENTIFIER <idcol>]					;
	     [<fupdt: FOR UPDATE>]					;
	     [ORDER BY <ocols,...> [INDEX <iname>]]			;
	     [SELECT <scols,...>]					;
	     [<exrcc: EXACT RECCOUNT>]					;
	=>    SqlV(IIF(<.wcond.>,SqlSetOpt(SQL_OPT_WHERE,<wcond>),1))   ;
	    ; SqlV(IIF(<.idcol.>,SqlSetOpt(SQL_OPT_ID,<"idcol">),1))	;
	    ; SqlV(IIF(<.fupdt.>,SqlSetOpt(SQL_OPT_FOR_UPDATE,<.fupdt.>),1)) ;
	    ; SqlV(IIF(<.ocols.>,SqlSetOpt(SQL_OPT_ORDER,<"ocols">),1)) ;
	    ; SqlV(IIF(<.iname.>,SqlSetOpt(SQL_OPT_INDEX_NAME,<"iname">),1)) ;
	    ; SqlV(IIF(<.scols.>,SqlSetOpt(SQL_OPT_COLUMNS,<"scols">),1)) ;
	    ; SqlV(IIF(<.exrcc.>,SqlSetOpt(SQL_OPT_EXACT_RECCOUNT,<.exrcc.>),1)) ;
      	    ; dbUseArea( <.new.>, "MEDSQL", <(db)>, <(a)>, .T., <.ro.> )           

#command SQLSEEK <xpr1>, <xpr2>                                         ;
         [<soft: SOFTSEEK>]                                             ;
	     => sqlDbSeek( <xpr1>, <xpr2>, if( <.soft.>, .T., NIL ) )



#command SQLGENSEEK <cn1> = <x1> [, <cnn> = <xn> ] ;
		=> sqlGSeek(<"cn1">,<x1>[,<"cnn">,<xn>])

#command SQLSQLSEEK <sqlcond> ;
		=> sqlSSeek(<sqlcond>)



#command SQL SET ORDER [TO] <ocols,...> ;
	 	[INDEX <iname>]	    ; 
				=> SqlSetOrd(<"iname">,<"ocols">)
#command SQL SET ORDER [TO]		=> SqlSetOrd()

#command SQL SET WHERE [TO] <wexp>	=> SqlSetWhr(<wexp>)
#command SQL SET WHERE [TO]		=> SqlSetWhr()

